#library "NewTIP"
#Include "zcommon.acs"

#define GVHEHCLASSES          16
#define TIPCOUNT            2
#define MAX_PLAYERS 64
#define TIP_SCROLLRATE      8



//Extracted from SAMSARA. 
int ClientTipboxes[MAX_PLAYERS];
int ClientTipboxModifier, ClientTipClassModifier;

function int itof(int x) { return x << 16; }
function int ftoi(int x) { return x >> 16; }

function int abs(int x)
{
    if (x < 0) { return -x; }
    return x;
}

function int sign(int x)
{
    if (x < 0) { return -1; }
    return 1;
}

function int randSign(void)
{
    return (2*random(0,1))-1;
}

function int mod(int x, int y)
{
    int ret = x - ((x / y) * y);
    if (ret < 0) { ret = y + ret; }
    return ret;
}

function int pow(int x, int y)
{
    int n = 1;
    while (y-- > 0) { n *= x; }
    return n;
}

function int powFloat(int x, int y)
{
    int n = 1.0;
    while (y-- > 0) { n = FixedMul(n, x); }
    return n;
}

function int min(int x, int y)
{
    if (x < y) { return x; }
    return y;
}

function int max (int x, int y)
{
    if (x > y) { return x; }
    return y;
}

function int middle(int x, int y, int z)
{
    if ((x < z) && (y < z)) { return max(x, y); }
    return max(min(x, y), z);
}

function int percFloat(int intg, int frac)
{
    return itof(intg) + (itof(frac) / 100);
}

function int percFloat2(int intg, int frac1, int frac2)
{
    return itof(intg) + (itof(frac1) / 100) + (itof(frac2) / 10000);
}

function int keyUp(int key)
{
    int buttons = GetPlayerInput(-1, INPUT_BUTTONS);

    if ((~buttons & key) == key) { return 1; }
    return 0;
}

function int keyDown(int key)
{
    int buttons = GetPlayerInput(-1, INPUT_BUTTONS);

    if ((buttons & key) == key) { return 1; }
    return 0;
}

function int keyDown_any(int key)
{
    int buttons = GetPlayerInput(-1, INPUT_BUTTONS);

    if (buttons & key) { return 1; }
    return 0;
}

function int keysPressed(void)
{
    int buttons     = GetPlayerInput(-1, INPUT_BUTTONS);
    int oldbuttons  = GetPlayerInput(-1, INPUT_OLDBUTTONS);
    int newbuttons  = (buttons ^ oldbuttons) & buttons;

    return newbuttons;
}

function int keyPressed(int key)
{
    if ((keysPressed() & key) == key) { return 1; }
    return 0;
}

function int keyPressed_any(int key)
{
    if (keysPressed() & key) { return 1; }
    return 0;
}

function int roundZero(int toround)
{
    int i = toround % 1.0;
    return ftoi(toround - i);
}

function int roundAway(int toround)
{
    int i = toround % 1.0;

    if (i == 0) { return ftoi(toround); }
    return ftoi(toround + (1.0 - i));
}

function int round(int toround)
{
    return ftoi(toround + 0.5);
}

int Tipboxes[GVHEHCLASSES][TIPCOUNT] =
{
    {"MRNTIPX", "MRNTIPX"},
    {"HUNTIP1", "HUNTIP2"},
    {"CYBTIP1", "CYBTIP1"},
    {"GBSTIP1", "GBSTIP1"},
    {"ENGTIP1", "ENGTIP1"},
	{"SJSTIP1", "SJSTIP1"},
    {"CRETIP1", "CRETIP1"},
    {"JITTIP1", "JITTIP1"},
    {"CHKTIP1", "CHKTIP1"},
    {"FRBTIP1", "FRBTIP1"},
    {"QRWTIP1", "QRWTIP2"},
    {"SWMTIP1", "SWMTIP1"},
    {"SNGTIP1", "SNGTIP1"},
	{"EXLTIP1", "EXLTIP2"},
    {"DMLTIP1", "DMLTIP1"},
    {"VWRTIP1", "VWRTIP2"},
};

int GVHEHCLASSITM[GVHEHCLASSES] =
{
    "DualPistols",
    "Bow",
    "CyborgPlasma",
    "GhostBusterTraps",
    "Nailgun",
	"Sjashands",
    "CreeperWeapon",
    "JitterSkullWeapon",
    "ChokeTeeth",
    "FrostTeeth",
    "NeverClaws",
    "Swampclaws",
    "SangelClaws1",
	"NailCannon",
    "Strifepistol",
    "PhaseSword",
};

function int GVHEHClassNum (void)
{
    int i;

    for (i = 0; i < GVHEHCLASSES; i++)
    {
        if (CheckInventory(GVHEHCLASSITM[i])) { return i; }
    }

    return -1;
}

script 3000 (int mode, int arg1, int arg2) net clientside
{
    switch (mode)
    {
      case 0:
        ClientTipClassModifier += arg1;
        break;

      case 1:
        ClientTipboxModifier += arg1;
        break;
    }
}

script 2999 (void) net
{
    int pln = PlayerNumber();

    ClientTipboxes[pln] = !ClientTipboxes[pln];

    SetPlayerProperty(0, ClientTipboxes[pln], PROP_TOTALLYFROZEN);
    ACS_ExecuteAlways(2998, 0, ClientTipboxes[pln], 0, 0);
}

script 2998 (int tipon, int mode) clientside
{
    int tipclass;
    int tipnum = 0;
    int pln = PlayerNumber();

    int i, j, modc, modn, modx, mody, classmod, tipscroll;

    // Comment out for ZDoom
    if (ConsolePlayerNumber() != pln) { terminate; } // Unnecessary but nice to not have assumptions made

    if (PlayerIsSpectator(pln)) { tipclass = random(1, GVHEHCLASSES) - 1; }
    else { tipclass = GVHEHClassNum(); }

    ClientTipboxes[pln] = tipon;
    ClientTipboxModifier = 0;
    ClientTipClassModifier = 0;

    while (ClientTipboxes[pln])
    {
        SetHudSize(1024, 768, 1);

        for (i = -2; i <= 2; i++)
        {
            modc = mod(tipclass + i, GVHEHCLASSES);
            modn = tipnum;

            j = 900 * tipscroll;
            j -= (j % 1.0);
            modx = itof(512 + (900 * i)) - j;


            //if (modx < 0) { modx -= 0.6; }
            //else { modx += 0.4; }

            j = "";
            if (j == "") { j = Tipboxes[modc][modn]; }

            SetFont(j);
            HudMessage(s:"A"; HUDMSG_FADEOUT, -6281 + i, CR_UNTRANSLATED, modx, 375.0, 1.0, 0.5);
        }

        classmod += keyPressed(BT_RIGHT) + keyPressed(BT_MOVERIGHT);
        classmod -= keyPressed(BT_LEFT) + keyPressed(BT_MOVELEFT);
        classmod += ClientTipClassModifier;
        
        tipscroll += itof(classmod) / TIP_SCROLLRATE;

        if (ftoi(abs(tipscroll)))
        {
            tipclass  += roundZero(tipscroll);
            classmod  -= roundZero(tipscroll);
            tipscroll %= 1.0;
        }

        if (classmod== 0)
        {
            classmod = -roundAway(tipscroll);
        }

        tipclass = mod(tipclass, GVHEHCLASSES);

        tipnum -= keyPressed(BT_FORWARD) + keyPressed(BT_LOOKUP);
        tipnum += keyPressed(BT_BACK) + keyPressed(BT_LOOKDOWN);
        tipnum += ClientTipboxModifier;
        tipnum = mod(tipnum, TIPCOUNT);

        
        SetFont("SMALLFONT");
        if (PlayerIsSpectator(pln))
        {
            HudMessage(k:"GVHEH_tipleft", s:"\cj to scroll left";
                            HUDMSG_PLAIN, -8281, CR_GOLD, 362.4, 712.1, 1.0, 0.5);

            HudMessage(k:"GVHEH_tipdown", s:"\cj change tipbox mode";
                            HUDMSG_PLAIN, -8283, CR_GOLD, 512.4, 726.1, 1.0, 0.5);
        }
        else
        {
            HudMessage(k:"+left", s:"\cj or \c-", k:"+moveleft", s:"\cj to scroll left";
                            HUDMSG_PLAIN, -8281, CR_GOLD, 362.4, 712.1, 1.0, 0.5);

            HudMessage(k:"+right", s:"\cj or \c-", k:"+moveright", s:"\cj to scroll right";
                            HUDMSG_PLAIN, -8282, CR_GOLD, 662.4, 712.1, 1.0, 0.5);

            HudMessage(s:"\cj(\c-", k:"+forward", s:"\cj, \c-", k:"+lookup", s:"\cj) and (\c-", k:"+back", s:"\cj, \c-", k:"+lookdown", s:"\cj) change tipbox mode";
                            HUDMSG_PLAIN, -8283, CR_GOLD, 512.4, 726.1, 1.0, 0.5);
        }

        ClientTipboxModifier = 0;
        ClientTipClassModifier = 0;
        Delay(1);
    }
}

